library leadlinkopenapi;

import 'dart:io';
import 'dart:math';
import 'dart:convert';
import 'package:flutter/material.dart';
import 'package:leancloud_storage/leancloud.dart';
import 'package:parse_server_sdk/parse_server_sdk.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:random_string/random_string.dart';
import 'package:device_info/device_info.dart';
import 'package:connectivity/connectivity.dart';
import 'package:common_utils/common_utils.dart';
import 'package:encrypt/encrypt.dart' as EPT;

part 'api_account_manager.dart';
part 'api_feedback.dart';
part 'api_leadlink_qrcode.dart';
part 'api_operation_log.dart';
part 'api_package_update.dart';
part 'api_product.dart';
part 'api_scheme.dart';
part 'api_model.dart';
part 'api_user.dart';
part 'api_product_sku.dart';
part 'api_util.dart';
part 'api_tip.dart';

// 力联开放接口
class LeadLinkOpenApi {


  // 初始化
  static Future<bool> init() async {

    try {
    
        final encrypted = 'hY481hCQsx+1wuZNbNLTOqEO9WyQCUZBaUGw+6C+EJmxdqU8epyqvDbeTRstuOTkg8j60sABBj' +
        'xfAAG9r4oNM2r0ZjcfppF4GbwBGarBxkrr/B692dp9vdIUq3mf1rkcb2W+d0fsKBnz4++ZYI4JopZGNggyOSbXwRhwc7D' +
        'DV5hvEf/Y68nnd3cv6ZhgdkCxscr0jPjDF8htQj/IN+fJM66IjdntccNglnG8E0Org1IpnWy9EGQvD5WQqeb7JO7McRhP2' +
        'CD4smrkxRLmkkWUwfmpmD2g56T5eXiyw8wbVOb9IqOIYTEMEogax/9D8/mD';

        Map<String,dynamic> m  = jsonDecode(APIUtil.decrypted(encrypted));
        
        LeanCloud.initialize(m['li'], m['lk'],server: m['ls'],queryCache: LCQueryCache());
        Parse parse = await Parse().initialize(m['pi'],m['ps'],masterKey: m['pk'],
          registeredSubClassMap: <String,ParseObjectConstructor>{

            ProblemType.kTableName :()=>ProblemType(),
            AccessType.kTableName:()=> AccessType(),
            ProblemFeedback.kTableName:()=>ProblemFeedback(),
            PackageUpdate.kTableName:()=>PackageUpdate(),

            ProductCategory.kTableName:()=>ProductCategory(),
            Product.kTableName:()=>Product(),
            ProductSKU.kTableName:()=>ProductSKU(),

            UserScheme.kTableName:()=>UserScheme(),
            
            Users.kTableName:()=>Users(),
            UserType.kTableName:()=>UserType(),
          },
        );

        final isParseOK =  parse.hasParseBeenInitialized();
        if(isParseOK == false) return false;

        return true;

    } 
    catch (e) {
      return false;
    }

  }


}
